export class Click {

    constructor(camera, renderer) {
        this.handler = () => {
            let width = renderer.domElement.parentNode.offsetWidth;
            let height = renderer.domElement.parentNode.offsetHeight;
            camera.aspect = width / height;
            renderer.setSize(width, height);
            camera.updateProjectionMatrix();
            return true;
        };
    }

    register() {
        return window.addEventListener("resize", this.handler, false);
    }

    unregister() {
        return window.removeEventListener("resize", this.handler);
    }

}
